"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MOS6502_1 = require("../common/cpu/MOS6502");
var disasm6502_1 = require("../common/cpu/disasm6502");
var CPUSimulator = /** @class */ (function () {
    function CPUSimulator() {
        this.cpu = new MOS6502_1.MOS6502();
        this.ram = new Uint8Array(0x10000);
    }
    CPUSimulator.prototype.read = function (a) {
        return this.ram[a] & 0xff;
    };
    CPUSimulator.prototype.write = function (a, v) {
        this.ram[a] = v;
    };
    CPUSimulator.prototype.readConst = function (a) {
        return this.ram[a] & 0xff;
    };
    CPUSimulator.prototype.tick = function () {
        this.cpu.advanceInsn();
        this.log();
    };
    CPUSimulator.prototype.log = function () {
        var pc = this.cpu.getPC();
        var b0 = this.readConst(pc);
        var b1 = this.readConst(pc);
        var b2 = this.readConst(pc);
        var line = disasm6502_1.disassemble6502(pc, b0, b1, b2);
        console.log(line);
    };
    return CPUSimulator;
}());
var sim = new CPUSimulator();
sim.tick();
sim.tick();
sim.tick();
//# sourceMappingURL=sim6502.js.map